#[cfg(test)]
mod tests {
    // Note this useful idiom: importing names from outer (for mod tests) scope.
    use crate::target::Target;
    use crate::main::Game;
    use std::time::Instant;

    #[test]
    fn test_target() {
        let new_update = Instant::now();
        let mut t = Target::new(
            10.0,
            52.0,
            30.0,
            -10.0,
            5.0,
            new_update,
            [0.0, 1.0, 0.0, 1.0],
            50
        );

        //points
        assert_eq!(50, t.get_points());

        //get_position
        assert_eq!((10.0, 52.0), t.get_position());

        //set_position+get_position
        t.set_position(&100.0, &10.0);
        assert_eq!((100.0, 10.0), t.get_position());

        //is_hit
        assert_eq!(t.is_hit(&110.0, &20.0), true);
        assert_eq!(t.is_hit(&130.0, &40.0), true);
        assert_eq!(t.is_hit(&99.9, &20.0), false);
        assert_eq!(t.is_hit(&120.0, &9.0), false);

        //is_inside_window+set_position
        assert_eq!(t.is_inside_window(&420.0, &200.0), true);
        t.set_position(&100.0, &-30.0);
        assert_eq!(t.is_inside_window(&420.0, &200.0), true);
        t.set_position(&100.0, &-30.1);
        assert_eq!(t.is_inside_window(&420.0, &200.0), false);
        t.set_position(&100.0, &200.0);
        assert_eq!(t.is_inside_window(&420.0, &200.0), true);
        t.set_position(&100.0, &200.1);
        assert_eq!(t.is_inside_window(&420.0, &200.0), false);
        t.set_position(&-30.0, &100.0);
        assert_eq!(t.is_inside_window(&420.0, &200.0), true);
        t.set_position(&-30.1, &100.0);
        assert_eq!(t.is_inside_window(&420.0, &200.0), false);
        t.set_position(&420.0, &100.0);
        assert_eq!(t.is_inside_window(&420.0, &200.0), true);
        t.set_position(&420.1, &100.0);
        assert_eq!(t.is_inside_window(&420.0, &200.0), false);
    }
}